#include "layout.h"
#include "object.h"

using namespace Msp;

namespace R2C2 {

Object3D::Object3D(Layout3D &l, Object &o):
	layout(l),
	object(o)
{
	object.signal_moved.connect(sigc::mem_fun(this, &Object3D::moved));
	moved();

	layout.add(*this);
}

Object3D::~Object3D()
{
	layout.remove(*this);
}

void Object3D::moved()
{
	matrix = GL::Matrix::translation(object.get_position());
	matrix.rotate(object.get_rotation(), 0, 0, 1);
	matrix.rotate(object.get_tilt(), 0, -1, 0);
}

} // namespace R2C2
