#include <msp/strings/format.h>
#include "elevatetool.h"

using namespace std;
using namespace Msp;
using namespace R2C2;

ElevateTool::ElevateTool(Designer &d, Input::Keyboard &k, Input::Mouse &m, const set<Object *> &o):
	Manipulator(d, k, m, o)
{
	origin = pointer.y;
}

void ElevateTool::axis_motion(unsigned axis, float value, float)
{
	if(axis==1)
	{
		Vector offset(0, 0, value-origin);

		signal_status.emit(format("Elevation: %+.0fmm (%.0fmm)", offset.z*1000, (center.z+offset.z)*1000));

		for(ObjectArray::iterator i=objects.begin(); i!=objects.end(); ++i)
			i->object->set_position(center+i->original_position+offset);
	}
}
