#ifndef MEASURE_H_
#define MEASURE_H_

#include <sigc++/sigc++.h>
#include <msp/gl/renderable.h>
#include "libr2c2/geometry.h"
#include "tool.h"

class Designer;

class Measure: public Tool, public Msp::GL::Renderable
{
private:
	R2C2::Snap start;
	bool start_pinned;
	float par_dist;
	float perp_dist;
	R2C2::Angle adiff;
	Msp::GL::Mesh mesh;

public:
	Measure(Designer &, Msp::Input::Keyboard &, Msp::Input::Mouse &);
	virtual ~Measure();

	float get_parallel_distance() const { return par_dist; }
	float get_perpendicular_distance() const { return perp_dist; }
	const R2C2::Angle &get_angle_difference() const { return adiff; }

private:
	void back();
	virtual void key_press(unsigned);
	virtual void button_press(unsigned);
	virtual void pointer_motion();

public:
	virtual void render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
private:
	void update_mesh();
	void snap_to_tracks(R2C2::Snap &);
};

#endif
