#ifndef NEWTRAINDIALOG_H_
#define NEWTRAINDIALOG_H_

#include <msp/gltk/dialog.h>
#include <msp/gltk/dropdown.h>
#include <msp/gltk/entry.h>
#include <msp/gltk/listdata.h>
#include "libr2c2/catalogue.h"
#include "libr2c2/driver.h"

class Engineer;

class NewTrainDialog: public Msp::GLtk::Dialog
{
private:
	Engineer &engineer;
	Msp::GLtk::BasicListData<std::string> protocols;
	Msp::GLtk::Dropdown *drp_protocol;
	Msp::GLtk::Entry *ent_address;
	Msp::GLtk::Entry *ent_name;
	Msp::GLtk::FunctionListData<const R2C2::VehicleType *> loco_types;
	Msp::GLtk::Dropdown *drp_loco_type;

public:
	NewTrainDialog(Engineer &);

	void prefill(const R2C2::Driver::DetectedLocomotive &);

private:
	virtual void on_response(int);
};

#endif
